<?php
/*******************************************************************
 *			
 * 			Fichier			:	profil_cp.php 
 * 			Cr le			:	02 mars 2003 
 * 			Dernire modif	:	16 aout 2003 
 * 			Email			:	wascripts@phpcodeur.net 
 * 
 * 				Copyright  2002-2003 phpCodeur
 * 
 *******************************************************************/

/*******************************************************************
 *  This program is free software; you can redistribute it and/or 
 * 	modify it under the terms of the GNU General Public License as 
 * 	published by the Free Software Foundation; either version 2 of 
 *  the License, or (at your option) any later version. 
 *******************************************************************/


define('IN_NEWSLETTER', true);

$waroot = './';
require($waroot . 'start.php');

if( !$nl_config['enable_profil_cp'] )
{
	load_settings();
	trigger_error('Profil_cp_disabled', MESSAGE);
}

include($waroot . 'includes/functions.validate.php');
include($waroot . 'includes/tags.inc.php');

//
// Instanciation d'une session
//
include($waroot . 'includes/class.sessions.php');
$session = new Session();

function check_login($email, $regkey = '', $passwd = '')
{
	global $db, $other_tags;
	
	$sql = "SELECT a.*, al.format, l.* 
		FROM " . ABONNES_TABLE . " AS a, " . ABO_LISTE_TABLE . " AS al, " . LISTE_TABLE . " AS l 
		WHERE a.abo_id = al.abo_id 
			AND LOWER(a.abo_email) = '" . $db->escape(strtolower($email)) . "'";
	if( $regkey != '' && $passwd != '' )
	{
		$sql .= " AND ( a.abo_pwd = '$passwd' OR a.abo_register_key = '$regkey' )";
	}
	
	if( !($result = $db->query($sql)) )
	{
		trigger_error('Impossible de rcuprer les donnes de l\'abonn', CRITICAL_ERROR);
	}
	
	if( $row = $db->fetch_array($result) )
	{
		$abodata = array();
		$abodata['id']       = $row['abo_id'];
		$abodata['pseudo']   = $row['abo_pseudo'];
		$abodata['passwd']   = $row['abo_pwd'];
		$abodata['email']    = $row['abo_email'];
		$abodata['language'] = $row['abo_lang'];
		$abodata['regdate']  = $row['abo_register_date'];
		$abodata['regkey']   = $row['abo_register_key'];
		$abodata['status']   = $row['abo_status'];
		
		foreach( $other_tags AS $data )
		{
			$abodata[$data['column_name']] = $row[$data['column_name']];
		}
		
		$abodata['listes'] = array();
		
		do
		{
			$abodata['listes'][$row['liste_id']] = $row;
		}
		while( $row = $db->fetch_array($result) );
		
		return $abodata;
	}
	else
	{
		return false;
	}
}

$mode  = ( !empty($_REQUEST['mode']) ) ? $_REQUEST['mode'] : '';
$email = ( !empty($_REQUEST['email']) ) ? trim($_REQUEST['email']) : '';

//
// Vrification de l'authentification
//
if( $mode != 'login' && $mode != 'sendkey' )
{
	if( !empty($_COOKIE[$nl_config['cookie_name'] . '_abo']) )
	{
		$data = (array) unserialize(stripslashes($_COOKIE[$nl_config['cookie_name'] . '_abo']));
	}
	else
	{
		$data = array();
	}
	
	if( isset($data['email']) && isset($data['key']) && validate_pass($data['key']) )
	{
		if( $mode == 'logout' )
		{
			$session->send_cookie('abo', '', (time() - 3600));
			
			$mode = 'login';
		}
		else
		{
			$abodata = check_login($data['email'], $data['key'], $data['key']);
			if( !is_array($abodata) )
			{
				$mode = 'login';
			}
		}
	}
	else
	{
		$mode = 'login';
	}
}
//
// Fin de la vrification
//

$language = ( $mode == 'login' || $mode == 'sendkey' ) ? $nl_config['language'] : $abodata['language'];
load_settings(array('admin_lang' => $language));

switch( $mode )
{
	case 'login':
		if( isset($_POST['submit']) )
		{
			$regkey = ( !empty($_POST['passwd']) ) ? trim($_POST['passwd']) : '';
			$result = check_email($email, -1, '', true);
			
			if( !$result['error'] )
			{
				if( !empty($regkey) && validate_pass($regkey) && ($abodata = check_login($email, $regkey, md5($regkey))) )
				{
					if( $abodata['status'] == ABO_ACTIF )
					{
						$key  = ( $regkey == $abodata['regkey'] ) ? $regkey : md5($regkey);
						$data = serialize(array('email' => $abodata['email'], 'key' => $key));
						
						$session->send_cookie('abo', $data, (time() + 3600));
						
						Location('profil_cp.php');
					}
					
					trigger_error('Inactive_account', MESSAGE);
				}
				else
				{
					$error = TRUE;
					$msg_error[] = $lang['Message']['Error_login'];
				}
			}
			else
			{
				$error = TRUE;
				$msg_error[] = $result['message'];
			}
		}
		
		page_header();
		
		$template->set_filenames(array(
			'body' => 'login_body.tpl'
		));
		
		$template->assign_vars(array(
			'TITLE'          => $lang['Module']['login'],
			'L_LOGIN'        => $lang['Account_login'],
			'L_PASS'         => $lang['Account_pass'],
			'L_SENDKEY'      => $lang['Lost_key'],
			'L_VALID_BUTTON' => $lang['Button']['valid']
		));
		
		$template->pparse('body');
		break;
	
	case 'sendkey':
		if( isset($_POST['submit']) )
		{
			include($waroot . 'includes/functions.validate.php');
			
			$result = check_email($email, -1, '', true);
			
			if( !$result['error'] )
			{
				if( $abodata = check_login($email) )
				{
					list($liste_id, $listdata) = each($abodata['listes']);
					
					include_once($waroot . 'includes/class.mailer.php');
					
					$mailer = new Mailer($waroot . 'language/email_' . $nl_config['language'] . '/');
					
					if( $nl_config['use_smtp'] )
					{
						$mailer->smtp_path = $waroot . 'includes/';
						$mailer->use_smtp(
							$nl_config['smtp_host'],
							$nl_config['smtp_port'],
							$nl_config['smtp_user'],
							$nl_config['smtp_pass']
						);
					}
					
					$mailer->hebergeur = $nl_config['hebergeur'];
					$mailer->charset   = $lang['CHARSET'];
					$mailer->format	   = FORMAT_TEXTE;
					
					if( $abodata['pseudo'] != '' )
					{
						$address = array($abodata['pseudo'] => $abodata['email']);
					}
					else
					{
						$address = $abodata['email'];
					}
					
					$mailer->set_from($listdata['sender_email'], unhtmlspecialchars($listdata['liste_name']));
					$mailer->set_address($address);
					$mailer->set_subject($lang['Subject_email']['Sendkey']);
					$mailer->set_priority(3);
					$mailer->set_return_path($listdata['return_email']);
					
					$mailer->use_template('account_info', array(
						'EMAIL'    => $abodata['email'],
						'CODE'     => $abodata['regkey'],
						'URLSITE'  => $nl_config['urlsite'],
						'SIG'      => $listdata['liste_sig']
					));
					
					if( !$mailer->send() )
					{
						trigger_error('Failed_sending', ERROR);
					}
					
					trigger_error('IDs_sended', MESSAGE);
				}
				else
				{
					$error = TRUE;
					$msg_error[] = $lang['Message']['Unknown_email'];
				}
			}
			else
			{
				$error = TRUE;
				$msg_error[] = $result['message'];
			}
		}
		
		page_header();
		
		$template->set_filenames(array(
			'body' => 'sendkey_body.tpl'
		));
		
		$template->assign_vars(array(
			'TITLE'          => $lang['Title']['sendkey'],
			'L_EXPLAIN'      => nl2br($lang['Explain']['sendkey']),
			'L_LOGIN'        => $lang['Account_login'],
			'L_VALID_BUTTON' => $lang['Button']['valid']
		));
		
		$template->pparse('body');
		break;
	
	case 'editprofile':
		if( isset($_POST['submit']) )
		{
			$vararray = array('pseudo', 'language', 'current_pass', 'new_pass', 'confirm_pass');
			foreach( $vararray AS $varname )
			{
				${$varname} = ( !empty($_POST[$varname]) ) ? trim($_POST[$varname]) : '';
			}
			
			if( $language == '' || !validate_lang($language) )
			{
				$language = $nl_config['language'];
			}
			
			if( $current_pass != '' && md5($current_pass) != $abodata['passwd'] )
			{
				$error = TRUE;
				$msg_error[] = $lang['Message']['Error_login'];
			}
			
			$set_password = FALSE;
			if( $new_pass != '' && $confirm_pass != '' )
			{
				if( !validate_pass($new_pass) )
				{
					$error = TRUE;
					$msg_error[] = $lang['Message']['Alphanum_pass'];
				}
				else if( $new_pass != $confirm_pass )
				{
					$error = TRUE;
					$msg_error[] = $lang['Message']['Bad_confirm_pass'];
				}
				
				$set_password = TRUE;
			}
			
			if( !$error )
			{
				$sql_data = array(
					'abo_pseudo' => htmlspecialchars($pseudo),
					'abo_lang'   => $language
				);
				
				if( $set_password )
				{
					$sql_data['abo_pwd'] = md5($new_pass);
				}
				
				foreach( $other_tags AS $data )
				{
					if( !empty($_POST[$data['column_name']]) )
					{
						$sql_data[$data['column_name']] = trim($_POST[$data['column_name']]);
					}
				}
				
				if( !$db->query_build('UPDATE', ABONNES_TABLE, $sql_data, array('abo_id' => $abodata['id'])) )
				{
					trigger_error('Impossible de mettre le profil  jour', ERROR);
				}
				
				$meta = meta_refresh(sessid('profil_cp.php'), 4);
				trigger_error('Profile_updated', MESSAGE);
			}
		}
		
		include($waroot . 'includes/functions.box.php');
		
		page_header();
		
		$template->set_filenames(array(
			'body' => 'editprofile_body.tpl'
		));
		
		$template->assign_vars(array(
			'TITLE'          => $lang['Module']['editprofile'],
			'L_EXPLAIN'      => nl2br($lang['Explain']['editprofile']),
			'L_EMAIL'        => $lang['Email_address'],
			'L_PSEUDO'       => $lang['Abo_pseudo'],
			'L_LANG'         => $lang['Default_lang'],
			'L_NEW_PASS'     => $lang['New_pass'],
			'L_CONFIRM_PASS' => $lang['Conf_pass'],
			'L_VALID_BUTTON' => $lang['Button']['valid'],
			
			'EMAIL'    => $abodata['email'],
			'PSEUDO'   => $abodata['pseudo'],
			'LANG_BOX' => lang_box($abodata['language'])
		));
		
		foreach( $other_tags AS $data )
		{
			$template->assign_var($data['tag_name'], htmlspecialchars($abodata[$data['column_name']]));
		}
		
		if( $abodata['passwd'] != '' )
		{
			$template->assign_block_vars('password', array(
				'L_PASS' => $lang['Password']
			));
		}
		
		$template->pparse('body');
		break;
	
	case 'archives':
		trigger_error('Module_disabled', MESSAGE);
		break;
	
	default:
		page_header();
		
		$template->set_filenames(array(
			'body' => 'index_body.tpl'
		));
		
		$template->assign_vars(array(
			'TITLE'          => $lang['Title']['profil_cp'],
			'L_EXPLAIN'      => nl2br($lang['Welcome_profil_cp'])
		));
		
		$template->pparse('body');
		break;
}

page_footer();

?>